=== debian/changelog ===
libopenshot (0.3.0+dfsg1-0.1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Update copyright.
  * Update to debhelper-compat = 12.
  * Correct source compat to 3.0 (quilt).

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 03 Jan 2023 17:08:33 -0800

libopenshot (0.3.0+dfsg2+1151+202212111704+daily~ubuntu18.04.1) bionic; urgency=low

  * Auto build.

 -- Jonathan Thomas <jonathan@openshot.org>  Sun, 11 Dec 2022 17:04:03 +0000

libopenshot (0.3.0-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Sun, 11 Dec 2022 09:56:39 -0600

libopenshot (0.2.6-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Wed, 25 Aug 2021 11:35:49 -0500

libopenshot (0.2.5-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Tue, 03 Mar 2020 02:44:31 -0600
