=== debian/changelog ===
libopenshot (0.3.1+dfsg1-0.1~mx23+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 10 Apr 2023 11:59:03 -0700
