=== debian/control ===
Source: libopenshot
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               cppzmq-dev | python3-zmq,
               debhelper-compat ( = 12),
               dh-python,
               libasound2-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libbabl-dev,
               libfdk-aac-dev,
               libjsoncpp-dev,
               libmagick++-dev,
               libopencv-dev,
               libopenshot-audio-dev,
               libprotobuf-dev,
               libqt5svg5-dev,
               libswresample-dev,
               libswscale-dev,
               libzmq3-dev,
               lsb-release,
               pkg-config,
               protobuf-compiler,
               python3-dev,
               qtbase5-dev,
               swig
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Homepage: http://www.openshot.org/

Package: libopenshot23
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Replaces: libopenshot18,
          libopenshot19,
          libopenshot20,
          libopenshot21,
          libopenshot22
Description: library for high quality video editing
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the OpenShot library.

Package: libopenshot-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libopenshot23 (= ${binary:Version}), ${misc:Depends}
Suggests: libopenshot-doc
Description: development files for the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the development files for the OpenShot library.

Package: libopenshot-doc
Architecture: all
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Description: documentation of the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the documentation for the OpenShot library.

Package: python3-openshot
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Python bindings for the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the Python bindings for the OpenShot library.
