=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#DH_VERBOSE = 1

# Hardening flags.
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Environment information.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_DISTRIBUTION = $(shell lsb_release -i -s)
DEB_RELEASE = $(shell lsb_release -c -s)

EXTRA_CMAKE_ARGS =
BUILD_DOCS = yes

ifeq (Ubuntu,$(DEB_DISTRIBUTION))
  ifeq (bionic,$(DEB_RELEASE))
    EXTRA_CMAKE_ARGS = -DENABLE_DOCS=0
    BUILD_DOCS = no
  endif
endif

%:
	dh $@  

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DUSE_SYSTEM_JSONCPP=ON \
		-DBUILD_TESTING=0 $(EXTRA_CMAKE_ARGS)

override_dh_auto_build-indep:
ifeq (yes,$(BUILD_DOCS))
	dh_auto_build --indep -- doc
endif

override_dh_install-arch:
	dh_install --arch
	dh_python3 --arch

override_dh_install-indep:
ifeq (yes,$(BUILD_DOCS))
	dh_install --indep
	dh_doxygen --indep
endif

override_dh_installdocs-indep:
ifeq (yes,$(BUILD_DOCS))
	dh_installdocs --indep
endif

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym
