=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libopenshot-$1\.tar\.gz/ \
https://github.com/OpenShot/libopenshot/tags .*/v?(\d\S*)\.tar\.gz
