## libopenshot 0.3.2+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,8 @@
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
 
 ################ PROJECT VERSION ####################
-set(PROJECT_VERSION_FULL "0.3.1")
-set(PROJECT_SO_VERSION 24)
+set(PROJECT_VERSION_FULL "0.3.2")
+set(PROJECT_SO_VERSION 25)
 
 # Remove the dash and anything following, to get the #.#.# version for project()
 STRING(REGEX REPLACE "\-.*$" "" VERSION_NUM "${PROJECT_VERSION_FULL}")
