=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -20,9 +20,11 @@
 ###  TEST SOURCE FILES
 ###
 set(OPENSHOT_TESTS
+  AudioDeviceManager
   AudioWaveformer
   CacheDisk
   CacheMemory
+  Caption
   Clip
   Color
   Coordinate
@@ -34,6 +36,7 @@
   FrameMapper
   KeyFrame
   Point
+  Profiles
   QtImageReader
   ReaderBase
   Settings
