=== debian/changelog ===
libopenshot (0.3.2+dfsg1-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 22 May 2024 19:59:36 -0700

libopenshot (0.3.2+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * No change source upload to allow testing migration

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 13 Oct 2023 12:56:19 +0200

libopenshot (0.3.2+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.3.2+dfsg1
    - Update Build-Depends on libopenshot-audio-dev (>= 0.3.2)
    - Update .SO name for new upstream version
    - Refresh patches, remove those applied upstream
    - Add Build-Depends on libqt5svg5-dev
  * Update gbp.conf to DEP-14
  * Update Standards-Version to 4.6.2, no changes needed
  * Remove myself from uploaders
  * Update d/copyright for removed files

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 11 Oct 2023 15:46:16 +0200
